<?php
/*********************/
/*                   */
/*  DeZend For PHP5  */
/*  BY WwW.DeZend.CC */
/*   With Bendy [2]  */
/*                   */
/*********************/

class chinese
{

	var $table = "";
	var $iconv_enabled = false;
	var $unicode_table = array( );
	var $config = array
	(
		"SourceLang" => "",
		"TargetLang" => "",
		"GBtoUnicode_table" => "gb-unicode.table",
		"BIG5toUnicode_table" => "big5-unicode.table"
	);

	function chinese( $SourceLang, $TargetLang, $ForceTable = FALSE )
	{
		$this->config['SourceLang'] = $this->_lang( $SourceLang );
		$this->config['TargetLang'] = $this->_lang( $TargetLang );
		$this->iconv_enabled = false;
		$this->opentable( );
	}

	function _lang( $LangCode )
	{
		$LangCode = strtoupper( $LangCode );
		if ( substr( $LangCode, 0, 2 ) == "GB" )
		{
			return "GBK";
		}
		if ( substr( $LangCode, 0, 3 ) == "BIG" )
		{
			return "BIG5";
		}
		if ( substr( $LangCode, 0, 3 ) == "UTF" )
		{
			return "UTF-8";
		}
		if ( substr( $LangCode, 0, 3 ) == "UNI" )
		{
			return "UNICODE";
		}
	}

	function _hex2bin( $hexdata )
	{
		$i = 0;
		for ( ;	$i < strlen( $hexdata );	$i += 2	)
		{
			$bindata .= chr( hexdec( substr( $hexdata, $i, 2 ) ) );
		}
		return $bindata;
	}

	function opentable( )
	{
		$this->unicode_table = array( );
		if ( $this->config['SourceLang'] == "GBK" || $this->config['TargetLang'] == "GBK" )
		{
			$this->table = CODETABLE_DIR.$this->config['GBtoUnicode_table'];
		}
		else if ( $this->config['SourceLang'] == "BIG5" || $this->config['TargetLang'] == "BIG5" )
		{
			$this->table = CODETABLE_DIR.$this->config['BIG5toUnicode_table'];
		}
		$fp = fopen( $this->table, "rb" );
		$tabletmp = fread( $fp, filesize( $this->table ) );
		$key = $value = "";
		$i = 0;
		for ( ;	$i < strlen( $tabletmp );	$i += 10	)
		{
			list( $key, $value ) = explode( ",", str_replace( "\n", "", substr( $tabletmp, $i, 10 ) ) );
			if ( $this->config['TargetLang'] == "UTF-8" )
			{
				$this->unicode_table[hexdec( "0x".$key )] = "0x".$value;
			}
			else if ( $this->config['SourceLang'] == "UTF-8" )
			{
				$this->unicode_table[hexdec( "0x".$value )] = "0x".$key;
			}
			else if ( $this->config['TargetLang'] == "UNICODE" )
			{
				$this->unicode_table[hexdec( "0x".$key )] = $value;
			}
		}
	}

	function chsutoutf8( $c )
	{
		$str = "";
		if ( $c < 128 )
		{
			$str .= $c;
			return $str;
		}
		if ( $c < 2048 )
		{
			$str .= 192 | $c >> 6;
			$str .= 128 | $c & 63;
			return $str;
		}
		if ( $c < 65536 )
		{
			$str .= 224 | $c >> 12;
			$str .= 128 | $c >> 6 & 63;
			$str .= 128 | $c & 63;
			return $str;
		}
		if ( $c < 2097152 )
		{
			$str .= 240 | $c >> 18;
			$str .= 128 | $c >> 12 & 63;
			$str .= 128 | $c >> 6 & 63;
			$str .= 128 | $c & 63;
		}
		return $str;
	}

	function convert( $SourceText )
	{
		if ( $this->config['SourceLang'] == $this->config['TargetLang'] )
		{
			return $SourceText;
		}
		if ( $this->iconv_enabled )
		{
			if ( $this->config['TargetLang'] != "UNICODE" )
			{
				return iconv( $this->config['SourceLang'], $this->config['TargetLang'], $SourceText );
			}
			$return = "";
			while ( $SourceText != "" )
			{
				if ( 127 < ord( substr( $SourceText, 0, 1 ) ) )
				{
					$return .= "&#x".dechex( $this->utf8_unicode( iconv( $this->config['SourceLang'], "UTF-8", substr( $SourceText, 0, 2 ) ) ) ).";";
					$SourceText = substr( $SourceText, 2, strlen( $SourceText ) );
				}
				else
				{
					$return .= substr( $SourceText, 0, 1 );
					$SourceText = substr( $SourceText, 1, strlen( $SourceText ) );
				}
			}
			return $return;
		}
		if ( $this->config['TargetLang'] == "UNICODE" )
		{
			$utf = "";
			while ( $SourceText != "" )
			{
				if ( 127 < ord( substr( $SourceText, 0, 1 ) ) )
				{
					if ( $this->config['SourceLang'] == "GBK" )
					{
						$utf .= "&#x".$this->unicode_table[hexdec( bin2hex( substr( $SourceText, 0, 2 ) ) ) - 32896].";";
					}
					else if ( $this->config['SourceLang'] == "BIG5" )
					{
						$utf .= "&#x".$this->unicode_table[hexdec( bin2hex( substr( $SourceText, 0, 2 ) ) )].";";
					}
					$SourceText = substr( $SourceText, 2, strlen( $SourceText ) );
				}
				else
				{
					$utf .= substr( $SourceText, 0, 1 );
					$SourceText = substr( $SourceText, 1, strlen( $SourceText ) );
				}
			}
			return $utf;
		}
		$ret = "";
		if ( $this->config['SourceLang'] == "UTF-8" )
		{
			$out = "";
			$len = strlen( $SourceText );
			$i = 0;
			while ( $i < $len )
			{
				$c = ord( substr( $SourceText, $i++, 1 ) );
				switch ( $c >> 4 )
				{
				case 0 :
				case 1 :
				case 2 :
				case 3 :
				case 4 :
				case 5 :
				case 6 :
				case 7 :
					$out .= substr( $SourceText, $i - 1, 1 );
					break;
				case 12 :
				case 13 :
					$char2 = ord( substr( $SourceText, $i++, 1 ) );
					$char3 = $this->unicode_table[( $c & 31 ) << 6 | $char2 & 63];
					if ( $this->config['TargetLang'] == "GBK" )
					{
						$out .= $this->_hex2bin( dechex( $char3 + 32896 ) );
					}
					else
					{
						if ( !( $this->config['TargetLang'] == "BIG5" ) )
						{
							break;
						}
						$out .= $this->_hex2bin( $char3 );
					}
					break;
				case 14 :
					$char2 = ord( substr( $SourceText, $i++, 1 ) );
					$char3 = ord( substr( $SourceText, $i++, 1 ) );
					$char4 = $this->unicode_table[( $c & 15 ) << 12 | ( $char2 & 63 ) << 6 | ( $char3 & 63 ) << 0];
					if ( $this->config['TargetLang'] == "GBK" )
					{
						$out .= $this->_hex2bin( dechex( $char4 + 32896 ) );
					}
					else
					{
						if ( !( $this->config['TargetLang'] == "BIG5" ) )
						{
							break;
						}
						$out .= $this->_hex2bin( $char4 );
					}
				}
			}
			return $out;
		}
		while ( $SourceText != "" )
		{
			if ( 127 < ord( substr( $SourceText, 0, 1 ) ) )
			{
				if ( $this->config['SourceLang'] == "BIG5" )
				{
					$utf8 = $this->chsutoutf8( hexdec( $this->unicode_table[hexdec( bin2hex( substr( $SourceText, 0, 2 ) ) )] ) );
				}
				else if ( $this->config['SourceLang'] == "GBK" )
				{
					$utf8 = $this->chsutoutf8( hexdec( $this->unicode_table[hexdec( bin2hex( substr( $SourceText, 0, 2 ) ) ) - 32896] ) );
				}
				$i = 0;
				for ( ;	$i < strlen( $utf8 );	$i += 3	)
				{
					$ret .= chr( substr( $utf8, $i, 3 ) );
				}
				$SourceText = substr( $SourceText, 2, strlen( $SourceText ) );
			}
			else
			{
				$ret .= substr( $SourceText, 0, 1 );
				$SourceText = substr( $SourceText, 1, strlen( $SourceText ) );
			}
		}
		$SourceText = "";
		return $ret;
	}

	function utf8_unicode( $char )
	{
		switch ( strlen( $char ) )
		{
		case 1 :
			return ord( $char );
		case 2 :
			$n = ( ord( $char[0] ) & 63 ) << 6;
			$n += ord( $char[1] ) & 63;
			return $n;
		case 3 :
			$n = ( ord( $char[0] ) & 31 ) << 12;
			$n += ( ord( $char[1] ) & 63 ) << 6;
			$n += ord( $char[2] ) & 63;
			return $n;
		case 4 :
			$n = ( ord( $char[0] ) & 15 ) << 18;
			$n += ( ord( $char[1] ) & 63 ) << 12;
			$n += ( ord( $char[2] ) & 63 ) << 6;
			$n += ord( $char[3] ) & 63;
			return $n;
		}
	}

}

define( "CODETABLE_DIR", MAXCMS_ROOT."/inc/table/" );
?>
